#include "editor.h"

#define PALETTE_WIDTH  8   /* As number of tiles. Each tile is 8 pixels. */
#define PALETTE_HEIGHT 6
#define PALETTE_X 24       /* Must be a multiple of 8. */
#define PALETTE_Y 32
static int palette_cursor_pos=0;

char palette_map[] = {
	TILE_KYE,
	TILE_DIAMOND,
	TILE_TWIST_CW,
	TILE_TWIST_CCW,
	TILE_WALL_7,
	TILE_WALL_8,
	TILE_WALL_9,
	TILE_BLOB,
	
	TILE_ROCKY_E,
	TILE_ROCKY_W,
	TILE_SLIDER_E,
	TILE_SLIDER_W,
	TILE_WALL_4,
	TILE_WALL_5,
	TILE_WALL_6,
	TILE_VIRUS,
	
	TILE_ROCKY_N,
	TILE_ROCKY_S,
	TILE_SLIDER_N,
	TILE_SLIDER_S,
	TILE_WALL_1,
	TILE_WALL_2,
	TILE_WALL_3,
	TILE_TWISTER,
	
	TILE_PUSHER_E,
	TILE_PUSHER_W,
	DOOR_WE,
	DOOR_EW,
	TILE_STICKY_EW,
	TILE_STICKY_NS,
	TILE_EXPLODER,
	TILE_GNASHER,
	
	TILE_PUSHER_N,
	TILE_PUSHER_S,
	DOOR_SN,
	DOOR_NS,
	TILE_MAGNET_EW,
	TILE_MAGNET_NS,
	TILE_PIT,
	TILE_SPIKE,
	
	TILE_FUZZY,
	TILE_BOULDER,
	TILE_BLOCK
	};

//{{{
void enter_palette_state(void)
{
	int ii;
	
	draw_rect(PALETTE_X-2, PALETTE_Y-2, (PALETTE_WIDTH<<3)+5,
	           (PALETTE_HEIGHT<<3)+5);
	
	for(ii=0; ii<NUM_TILE_TYPES-1; ii++) {
		draw_sprite(tile_sprites[ (int)palette_map[ii] ],
		    PALETTE_X + ((ii%PALETTE_WIDTH)<<3),
		    PALETTE_Y + ((ii/PALETTE_WIDTH)<<3));
	}
	draw_palette_cursor();
	
	input_state = palette_state;
}
//}}}
//{{{
void draw_palette_cursor(void)
{
	draw_sprite_xor(black_square,
	                PALETTE_X + ((palette_cursor_pos%PALETTE_WIDTH)<<3),
	                PALETTE_Y + ((palette_cursor_pos/PALETTE_WIDTH)<<3));
}
//}}}
//{{{
void move_palette_cursor(int dd)
{
	if(palette_cursor_pos+dd < 0 || palette_cursor_pos+dd >= NUM_TILE_TYPES-1)
		return;
	draw_palette_cursor();
	palette_cursor_pos += dd;
	draw_palette_cursor();
}
//}}}
//{{{
void palette_state(int key)
{
	if(key == KEY_LEFT) {
		move_palette_cursor(-1);
	} else if(key == KEY_UP) {
		move_palette_cursor(-PALETTE_WIDTH);
	} else if(key == KEY_RIGHT) {
		move_palette_cursor(1);
	} else if(key == KEY_DOWN) {
		move_palette_cursor(PALETTE_WIDTH);
	} else if(key == KEY_ENTER) {
		edit_brush = palette_map[palette_cursor_pos];
		enter_edit_state();
	} else if(key == KEY_ESC) {
		enter_edit_state();
	}
}
//}}}

