#ifndef ENGINE_H
#define ENGINE_H

#define FIELD_WIDTH current_map.width
#define FIELD_HEIGHT current_map.height

#define ANIMATE_DIAMONDS
#define DELAY_TIME 4
#define MOVE_DELAY 5
#define EXPLODE_DURATION 4
#define VERSION_STRING "v1.0"

#define VIEWPORT_WIDTH (LCD_WIDTH/8)
#define VIEWPORT_HEIGHT ((LCD_HEIGHT-12)/8)
#define SCROLL_INCR_X 6
#define SCROLL_INCR_Y 4
#define EDGE_X 4
#define EDGE_Y 2

#define SCREEN_CENTER (LCD_WIDTH/2)

#include "cprotofix.h"
#define OPTIMIZE_ROM_CALLS
#define USE_TI89
#define USE_TI92P
#define USE_V200
#include <tigcclib.h>

#include "skye.h"

#define NUM_EFFECT_TYPES 10
//{{{
#define EFFECT_NONE              0
#define EFFECT_EXPLODE_TOPLEFT   1
#define EFFECT_EXPLODE_TOP       2
#define EFFECT_EXPLODE_TOPRIGHT  3
#define EFFECT_EXPLODE_LEFT      4
#define EFFECT_EXPLODE_CENTER    5
#define EFFECT_EXPLODE_RIGHT     6
#define EFFECT_EXPLODE_BOTLEFT   7
#define EFFECT_EXPLODE_BOTTOM    8
#define EFFECT_EXPLODE_BOTRIGHT  9
#define EFFECT_BLOB              10
#define EFFECT_VIRUS             11
#define EFFECT_TWISTER           12
#define EFFECT_GNASHER           13
#define EFFECT_SPIKE             14
#define EFFECT_DIAMOND           15
//}}}

typedef struct effect_info {
	unsigned char sprite;
	signed char duration;
} effect_info;

extern char active_set[32];

//{{{
typedef struct engine_map_square {
	map_square v;
	char skip;
	effect_info effect;
} engine_map_square;
//}}}
//{{{
// Game engine internal map format
typedef struct engine_map
{
	short width, height;
	short gamerules;
	
	char name[32];
	char author[32];
	char hint[64];
	char congrat[64];
	engine_map_square **t;
} engine_map;
//}}}

extern engine_map current_map;
extern int current_level_num;
extern int player_x, player_y;
extern const char tile_sprites[NUM_TILE_TYPES][24];
extern const char effects[NUM_EFFECT_TYPES][24];
extern const char black_square[24];

#ifdef SPLINT
#	define GrayIdle()
#else
#	define GrayIdle() pokeIO(0x600005,0b10111)
#endif

#ifndef CPROTO
#include "proto.h"
#endif

#endif //ENGINE_H
