#define SAVE_SCREEN
#include "engine.h"

//INT_HANDLER save_int_1;

static void CALLBACK cleanup(void);
//{{{
void _main(void)
{
	int loaded_set;
	show_title_screen();
	initialize();
	loaded_set = pick_set();
	while(loaded_set) {
		level_advance(0);
		game_loop();
		loaded_set = pick_set();
	}
}
//}}}
short saved_between_delay, saved_init_delay;
//{{{
void initialize(void)
{
	saved_init_delay = OSInitKeyInitDelay( 90 );
	saved_between_delay = OSInitBetweenKeyDelay( 30 );
	clrscr();
	GrayOn();
	atexit(cleanup);
}
//}}}
//{{{
static void CALLBACK cleanup(void)
{
	GrayOff();
	if(current_map.t) {
		free(current_map.t);
		current_map.t = NULL;
	}
	OSInitKeyInitDelay(saved_init_delay);
	OSInitBetweenKeyDelay(saved_between_delay);
}
//}}}

//{{{
void show_title_screen(void)
{
	clrscr();
	draw_string("SKye", 55, 20, F_8x10);
	draw_string(VERSION_STRING, 60, 31, F_4x6);
	draw_string("By Jim Babcock", 30, 40, F_4x6);
	draw_string("Based on Kye by Dillon Collins", 30, 47, F_4x6);
	draw_string("and on Kye by Colin Garbutt", 30, 54, F_4x6);
	read_char();
}
//}}}
//{{{
int show_splash(void)
{
	char buf[64];
	int font;
	clear_screen();
	sprintf(buf, "Level %i:", current_level_num+1);
	draw_string(buf, SCREEN_CENTER-DrawStrWidth(buf, F_4x6)/2, 20, F_4x6);
	if(strlen(current_map.name) <= 19) // Name short enough for 8x10 font
		font = F_8x10;
	else if(strlen(current_map.name) <= 26) // Name short enough for 6x8 font
		font = F_6x8;
	else                               // Very long name! Use 4x6.
		font = F_4x6;
	
	draw_string(current_map.name,
		SCREEN_CENTER - DrawStrWidth(current_map.name,font)/2, 28, font);
	
	if(strlen(current_map.author) > 0) {
		sprintf(buf, "By %s", current_map.author);
		draw_string(buf, SCREEN_CENTER-DrawStrWidth(buf, F_4x6)/2, 44, F_4x6);
	}
	
	draw_string("+",                      3, 80, F_4x6);
	draw_string("Next level",             8, 80, F_4x6);
	draw_string("-",                      3, 86, F_4x6);
	draw_string("Previous level",         8, 86, F_4x6);
	draw_string("Press any other key to begin", 3, 92, F_4x6);
	return read_char();
}
//}}}

//{{{
void message(const char *message)
{
	int in;
	int width = DrawStrWidth(message, F_4x6);
	int left = SCREEN_CENTER - width/2 - 5;
	
	draw_rect(left, 35, width+10, 10);
	draw_string(message, left+5, 37, F_4x6);
	
	do {
		in = read_char() & ~0x800;
		if(in == KEY_LEFT || in == KEY_RIGHT ||
		   in == KEY_UP || in == KEY_DOWN)
			continue;
		else
			break;
	} while(1);
}
//}}}

