#ifndef SKYE_H
#define SKYE_H

//#define FIELD_WIDTH  25
//#define FIELD_HEIGHT 16

typedef unsigned char map_square;
//{{{
typedef struct map_r1
{
	char name[32];
	char author[32];
	char unused[32];
	map_square t[11][20];
} map_r1;
//}}}
//{{{
typedef struct map_r2
{
	short width, height;
	short gamerules;
	short unused[5];
} map_r2;
//}}}
//{{{
// Level editor internal map format
typedef struct editor_map
{
	short width, height;
	short gamerules;
	
	char name[64];
	char author[64];
	char hint[64];
	char congrat[64];
	map_square **t;
} editor_map;
//}}}

#define NUM_TILE_TYPES 44
//{{{
// These first 31 tiles are the same as in Dillon Collins Kye
// This is to allow binary compatibility with DCKye kyelev and kyelib
// files.
#define TILE_EMPTY      0
#define TILE_KYE        1
#define TILE_SLIDER_S   2
#define TILE_SLIDER_E   3
#define TILE_SLIDER_N   4
#define TILE_SLIDER_W   5
#define TILE_ROCKY_S    6
#define TILE_ROCKY_E    7
#define TILE_ROCKY_N    8
#define TILE_ROCKY_W    9
#define TILE_DIAMOND   10
#define TILE_BLOCK     11
#define TILE_FUZZY     12
#define TILE_BOULDER   13
#define TILE_TWIST_CW  14
#define TILE_TWIST_CCW 15
#define TILE_STICKY_EW 16
#define TILE_STICKY_NS 17
#define TILE_PUSHER_W  18
#define TILE_PUSHER_E  19
#define TILE_PUSHER_N  20
#define TILE_PUSHER_S  21
	// DCKye has four values unused here, which probably were meant to
	// correspond to monsters. Rather than skipping numbers and making
	// a mess of the internal format, this will be handled in import/
	// export code.
#define TILE_UNUSED    22
   // Number points to the rounded corner/side on the numpad
#define TILE_WALL_5    22
#define TILE_WALL_3    23
#define TILE_WALL_9    24
#define TILE_WALL_7    25
#define TILE_WALL_1    26
#define TILE_WALL_2    27
#define TILE_WALL_6    28
#define TILE_WALL_8    29
#define TILE_WALL_4    30
#define TILE_EXPLODER  31
#define TILE_PIT       32
#define TILE_MAGNET_EW 33
#define TILE_MAGNET_NS 34
#define TILE_BLOB      35
#define TILE_VIRUS     36
#define TILE_TWISTER   37
#define TILE_GNASHER   38
#define TILE_SPIKE     39
#define DOOR_EW        40
#define DOOR_WE        41
#define DOOR_NS        42
#define DOOR_SN        43

// Not yet supported
#define TILE_AUTOROCKY  44
#define TILE_AUTOSLIDER 45
#define TILE_BLACKY    46
#define TILE_TIMER_0   47
#define TILE_TIMER_1   48
#define TILE_TIMER_2   49
#define TILE_TIMER_3   50
#define TILE_TIMER_4   51
#define TILE_TIMER_5   52
#define TILE_TIMER_6   53
#define TILE_TIMER_7   54
#define TILE_TIMER_8   55
#define TILE_TIMER_9   56
//}}}

//{{{
typedef struct file_header {
	char magic_bytes[4]; // Must be 'SKye' if this is an SKye-format level
	long revision;       // Version of the file format.
	long num_levels;     // Number of levels in the file
} file_header;
//}}}

#define RULESET_DCKYE 0
#define RULESET_KYE92 1

#endif
